// Copyright (c) 2017, the gRPC project authors. Please see the AUTHORS file
// for details. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// ignore: dangling_library_doc_comments
/// Status detail types and error codes
export 'package:grpc/src/generated/google/rpc/error_details.pb.dart';

export 'src/auth/auth.dart' show BaseAuthenticator;
export 'src/auth/auth_io.dart'
    show
        applicationDefaultCredentialsAuthenticator,
        ComputeEngineAuthenticator,
        ServiceAccountAuthenticator;
export 'src/client/call.dart' show ClientCall;
export 'src/client/client.dart' show Client;
export 'src/client/client_keepalive.dart' show ClientKeepAliveOptions;
export 'src/client/client_transport_connector.dart'
    show ClientTransportConnector;
export 'src/client/connection.dart' show ConnectionState;
export 'src/client/http2_channel.dart'
    show ClientChannel, ClientTransportConnectorChannel;
export 'src/client/interceptor.dart'
    show ClientInterceptor, ClientUnaryInvoker, ClientStreamingInvoker;
export 'src/client/method.dart' show ClientMethod;
export 'src/client/options.dart'
    show
        defaultIdleTimeout,
        BackoffStrategy,
        defaultBackoffStrategy,
        ChannelOptions;
export 'src/client/proxy.dart' show Proxy;
export 'src/client/transport/http2_credentials.dart'
    show BadCertificateHandler, allowBadCertificates, ChannelCredentials;
export 'src/server/call.dart' show ServiceCall;
export 'src/server/interceptor.dart' show Interceptor;
export 'src/server/server.dart'
    show
        ServerCredentials,
        ServerLocalCredentials,
        ServerTlsCredentials,
        ConnectionServer,
        Server;
export 'src/server/server_keepalive.dart' show ServerKeepAliveOptions;
export 'src/server/service.dart' show ServiceMethod, Service;
export 'src/shared/api.dart';
export 'src/shared/codec.dart' show Codec, IdentityCodec, GzipCodec;
export 'src/shared/codec_registry.dart';
export 'src/shared/message.dart'
    show GrpcMessage, GrpcMetadata, GrpcData, grpcDecompressor;
export 'src/shared/security.dart'
    show supportedAlpnProtocols, createSecurityContext;
export 'src/shared/streams.dart' show GrpcHttpEncoder, GrpcHttpDecoder;
export 'src/shared/timeout.dart' show toTimeoutString, fromTimeoutString;
